#! /usr/local/bin/python3

import sys
import re
import json

if len(sys.argv)!= 3 and len(sys.argv) != 4:
    print("parameters: input_file output_file \"list,of,labels\"")
    exit(1)
    
infile = sys.argv[1]
outfile = sys.argv[2]
filters = sys.argv[3].split(",") if len(sys.argv) == 4 else []

fragment = ""
c = 0

print("filtering for labels " + "/".join(filters))

with open(outfile, "w") as ofile:
    ofile.write("id,label\n")
    with open(infile, "r", encoding="utf-8") as ifile:
        raw_lines = ifile.readlines()
        for i in range(len(raw_lines)):
            line = raw_lines[i].rstrip('\n')
            fragment += line
            if i < len(raw_lines)-1:
                nextline = raw_lines[i + 1].rstrip('\n')
                if re.match("^\}\s*$",line) and re.match("^\{\s*$",nextline):
                    issue = json.loads(fragment)
                    fragment = ""
                    if "pull_request" not in issue['data'] and issue['data']['state'] == "closed":
                        labels = issue['data']['labels']
                        if labels:
                            for label_name in [label['name'].lower() for label in labels]:
                                if not filters or label_name in filters:
                                    ofile.write(str(issue['data']['id']) + "," + label_name + "\n")
                                    c += 1
                        elif not filters:
                            ofile.write(str(issue['data']['id']) + ",\n")
                            c += 1

print("Wrote " + str(c) + " matching issues to " + outfile)
