import os, glob
import re
import json
from pathlib import Path

package_dir = os.path.abspath(os.path.join(os.path.dirname(__file__), '..'))

all_ids = []
for path in Path(package_dir).rglob('*_sample.csv'):
    with open(path, "r") as f:
        for line in f.readlines()[1:]:
            line = line.strip()
            bugId = line.split(",")[0]
            all_ids.append(bugId)

final_csv = open("../issues/all_sampled_issues.csv", "w")
final_csv.write("number,title,url\n")

for path in Path(package_dir).rglob('*.json'):
    with open(path, "r") as f:
        fragment = ""
        c = 0
        print("Processing " + path.name)
        raw_lines = f.readlines()
        for i in range(len(raw_lines)):
            line = raw_lines[i].rstrip('\n')
            fragment += line
            if i < len(raw_lines)-1:
                nextline = raw_lines[i + 1].rstrip('\n')
                if re.match("^\}\s*$",line) and re.match("^\{\s*$",nextline):
                    try:
                        issue = json.loads(fragment)
                        if str(issue['data']['id']) in all_ids:
                            number = issue['data']['number']
                            title = issue['data']['title']
                            url = issue['origin'] + "/issues/" + str(number)
                            final_csv.write(str(number) + "," + title + "," + url + "\n")
                            c += 1
                    except:
                        print("An error has occured.")
                    fragment = ""
        print("Wrote " + str(c) + " entries")
final_csv.close()
